#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_27/sys/src/install/perl/SAPDB/Install/Control/UninstTreeCtrl.pm#1 $
# $DateTime: 2006/04/27 14:44:55 $
# $Change: 124736 $
#
# Desc: 


package SAPDB::Install::Control::UninstTreeCtrl;

use Wx qw(wxTreeItemIcon_Selected);

use base SAPDB::Install::Control::TreeCtrl;


sub Destroy{
	my ($self) = @_;
	$self->SUPER::Destroy;
}

sub UpdateItems{
	my ($self,$item,$text) = @_;
	return unless $self->ItemHasChildren($item);
	my @children;
	my ($child_id, $cookie) = $self->GetFirstChild ($item);
	push @children,$child_id;
	foreach (2 .. $self->GetChildrenCount($item,0)){
		($child_id, $cookie) = $self->GetNextChild ($item,$cookie);
		last unless defined $child_id;
		push @children,$child_id;
	}
	foreach my $child (@children){
		if($self->GetItemText($child) eq $text){
			if($self->GetPlData($child)->{'selected'}){
				$self->SetItemImage($child,1);
				$self->SetItemImage($child,1,wxTreeItemIcon_Selected);
				unless($self->GetPlData($item)->{'selected'}){
						$self->CheckChildren($child);
				}
			}
			else{
				$self->SetItemImage($child,2);
				$self->SetItemImage($child,2,wxTreeItemIcon_Selected);
			}	
		}
		$self->UpdateItems($child,$text);
	}
}


sub IsNoParentSelected{
	my ($self,$item,$name) = @_;
	my $rc = 1;
	return 1 unless $self->ItemHasChildren($item);
	my @children;
	my ($child_id, $cookie) = $self->GetFirstChild ($item);
	push @children,$child_id;
	foreach (2 .. $self->GetChildrenCount($item,0)){
		($child_id, $cookie) = $self->GetNextChild ($item,$cookie);
		last unless defined $child_id;
		push @children,$child_id;
	}
	foreach my $child (@children){
		if($self->GetItemText($child) eq $name){
			my $parent = $self->GetItemParent($child);
			if(defined $parent and defined $self->GetPlData($parent) and
				$self->GetPlData($parent)->{'selected'}){
				return 0;
			}					
		}
		else{
			$rc = $self->IsNoParentSelected($child,$name);
			return 0 unless $rc;
		}
	}
	return $rc;
}



sub CheckItem{
	my ($self,$item) = @_;
	my $text = $self->GetItemText($item);
	if(defined $self->GetPlData($item)){
		return if $self->GetPlData($item)->{'type'} == 2;
		if($self->GetPlData($item)->{'selected'}){
			if(exists $self->{'dependent_nodes'}->{$text}){
				foreach my $ditem (@{$self->{'dependent_nodes'}->{$text}}){
					next if($ditem !~ /\S/);
					unless($self->IsNoParentSelected($self->GetRootItem(),$ditem)){
						return;
					}
				}		
			}
			my $parent = $self->GetItemParent($item); 
			if(defined $parent and defined $self->GetPlData($parent) and
			 $self->GetPlData($parent)->{'selected'}){
				return;
			}
			$self->GetPlData($item)->{'selected'} = 0;
			$self->SetItemImage($item,2);
			$self->SetItemImage($item,2,wxTreeItemIcon_Selected);
		}
		else{
			$self->GetPlData($item)->{'selected'} = 1;
			$self->SetItemImage($item,1);
			$self->SetItemImage($item,1,wxTreeItemIcon_Selected);
			$self->CheckChildren($item);
		}
		if(exists $self->{'dependent_nodes'}->{$text}){
			foreach my $ditem (@{$self->{'dependent_nodes'}->{$text}}){
				next if($ditem !~ /\S/);
				$self->UpdateItems($self->GetRootItem(),$ditem);
			}		
		}
		
	 
	}	
}




sub DESTROY{
	my ($self) =  @_;
	print ">>>> DESTROY $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}


1;