#!/usr/bin/perl
#
# $Header: //sapdb/V76/develop/sys/src/install/perl/SAPDB/Install/App.pm#1 $
# $DateTime: 2004/03/11 10:29:37 $
# $Change: 66919 $
#
# Desc: start SAP DB installation/update/patch/instanceupgrade, called by SDBINST/SDBUPD

package SAPDB::Install::Frame::Desktop;

use Wx::Event qw (EVT_SIZE);

use Wx qw (wxDefaultSize wxWANTS_CHARS);

use SAPDB::Install::Resources;
use SAPDB::Install::Frame::Base;
use SAPDB::Install::Window::Banner;
use SAPDB::Install::Window::Desktop;
use SAPDB::Install::App::RegistryViewer;
use SAPDB::Install::App::Installer;
use SAPDB::Install::App::CreateInstance;
use SAPDB::Install::App::StartSetup;
use SAPDB::Install::App::Setup;

our @ISA = qw (SAPDB::Install::Frame::Base);

sub new {
 	my( $class ) = shift;
 	my( $this ) = $class->SUPER::new(@_);
	#$this->SetWindowStyle(wxWANTS_CHARS);
	#$this->Show(0);
	my $rc = SAPDB::Install::Resources->new('RESOURCES.TGZ');
	$rc->readAll;
	$this->{'banner'} = SAPDB::Install::Window::Banner->new($this,-1,[0,0],wxDefaultSize,wxWANTS_CHARS);
	$this->{'desk'} = SAPDB::Install::Window::Desktop->new($this,-1,[0,80],wxDefaultSize,wxWANTS_CHARS);
	$this->{'desk'}->SetWindowStyle(wxWANTS_CHARS);
	#$this->SetNextHandler($this->{'desk'});
	$this->{'desk'}->initDesk([['Software Installation','icon/package.png',\&SAPDB::Install::StartGui::main],
				['InstallRegistry Viewer','icon/viewer.png',\&SAPDB::Install::App::RegistryViewer::main],
				['Instance Update','icon/insticon.png'],
				['Software Deinstallation','icon/uninstall.png'],
				['Software Installation (NEW)','icon/package.png',\&SAPDB::Install::App::Installer::main],
				['Create Instance','icon/insticon.png',\&SAPDB::Install::App::CreateInstance::main],
				['SDBSETUP (old)','icon/insticon.png',\&SAPDB::Install::App::Setup::main],
				['SDBSETUP (new)','icon/insticon.png',\&SAPDB::Install::App::StartSetup::main]]);


	EVT_SIZE($this,\&OnSize);
	$this->OnSize;
	$this->Show(1);
	$this->{'desk'}->SetFocus(); 
	$this;
}

sub OnSize{
	my ($self,$event) = @_;
	$self->{'banner'}->SetSize([$self->GetClientSize->GetWidth,80]);
	$self->{'desk'}->SetSize([$self->GetClientSize->GetWidth,$self->GetClientSize->GetHeight - 80]);
	$self->{'desk'}->SetFocus;

#####
#	own grid sizer with center alainment
#	$frame = empty  space arround the border in pixels
#	$ratio = ratio of columns and rows 
#######
	
#	my $frame = 50;
#	my $ratio = 3/4;
#
#	my ($x,$y) = $self->GetSizeWH;
#	$xsize = $x - ($frame * 2 );
#	$ysize = $y - ($frame * 2 ) - ($self->{'banner'}->GetSizeWH)[1];
#	$xpos = $frame;
#	$ypos = $frame + ($self->{'banner'}->GetSizeWH)[1];
#
#	my $col,$row;
#	my $id = 0;
#	my @icons = @{$self->{'icons'}}; 			
#	my $max_cols = sqrt(($#icons  + 1) * $ratio);
#	if(($max_cols - int($max_cols)) >= 0.5){
#		$max_cols = int($max_cols) + 1;
#	}
#	else{
#		$max_cols = int($max_cols);
#	}
#	my $max_rows = int(sqrt(($#icons  + 1) * (1/$ratio)));
#	if(($max_rows - int($max_rows)) >= 0.5){
#		$max_rows = int($max_rows) + 1;
#	}
#	else{
#		$max_rows = int($max_rows);
#	}
#
#	my $cell_size = [int($xsize/$max_cols),int($ysize/$max_rows)];
#
#	foreach my $icon (@icons){
#		$row = int($id / $max_cols);
#		$col = $id % $max_cols;
#		my $xadd = int(($cell_size->[0] - ($icon->GetSizeWH)[0]) / 2);
#		my $yadd = int(($cell_size->[1] - ($icon->GetSizeWH)[1]) / 2);
#		$icon->Move([$xpos +$xadd + $col * int($xsize / $max_cols),$ypos + $yadd + $row * int($ysize / $max_rows)]);
#		print ">>>> $id: ($col,$row)\n";
#		$id++;
#	}
#
#	return 1;
}


1;

