#!/usr/bin/perl
#
# $Header: //sapdb/V76/develop/sys/src/install/perl/SAPDB/Install/App.pm#1 $
# $DateTime: 2004/03/11 10:29:37 $
# $Change: 66919 $
#
# Desc: start SAP DB installation/update/patch/instanceupgrade, called by SDBINST/SDBUPD

package SAPDB::Install::Frame::Instance;
use Wx::Event qw (EVT_SIZE);

use Wx qw (
	wxBITMAP_TYPE_ICO wxBITMAP_TYPE_BMP wxBLUE wxWHITE wxMENU_TEAROFF wxOK
	wxICON_INFORMATION wxSPLASH_TIMEOUT wxVERSION_STRING wxDefaultSize
	wxNullBitmap wxYES_NO wxSPLASH_CENTRE_ON_SCREEN wxDefaultPosition
	wxSIMPLE_BORDER wxFRAME_NO_TASKBAR wxSTAY_ON_TOP wxCENTRE wxID_YES
	wxDECORATIVE wxNORMAL wxBOLD wxICON_QUESTION wxNO_DEFAULT
	wxHOURGLASS_CURSOR wxNullCursor wxEVT_COMMAND_BUTTON_CLICKED
	wxSPLIT_VERTICAL wxTE_READONLY wxTE_MULTILINE);

use SAPDB::Install::Frame::Base;
use SAPDB::Install::Window::Banner;
use SAPDB::Install::Window::Wizard;
use SAPDB::Install::Wizard::Dialog::Collector;
use SAPDB::Install::Wizard::Dialog::CreateInstance;
use SAPDB::Install::Wizard::Dialog::Finalize;
use SAPDB::Install::Wizard::Dialog::Install;		
use SAPDB::Install::Wizard::Dialog::Parameter;
use SAPDB::Install::Wizard::Dialog::Prepare;
use SAPDB::Install::Wizard::Dialog::Template;


our @ISA = qw (SAPDB::Install::Frame::Base);

sub new {
 	my( $class ) = shift;
	my ($config) = shift;
 	my( $this ) = $class->SUPER::new($_[0], $_[1], $_[2] );
	$this->{'config'} = $config;
	#$this->SetBackgroundColour(wxWHITE);
	$this->{'next_id'} = 1; 
	$this->{'banner'} = SAPDB::Install::Window::Banner->new($this,$this->{'next_id'}++,[0,0],[$this->GetClientSize->GetWidth,80]);
	$this->{'wizard'} = SAPDB::Install::Window::Wizard->new($this,$this->{'next_id'}++,[0,80],[$this->GetClientSize->GetWidth,$this->GetClientSize->GetHeight - 80]);
	$this->{'wizard'}->AddStep({'name' => 'Template Selection',
								'dlg' => SAPDB::Install::Wizard::Dialog::Template->new($this->{'wizard'}->{'dlg_space'},$this->{'next_id'}++,[0,0],wxDefaultSize)}
					);
	$this->{'wizard'}->AddStep({'name' => 'Database Settings',
								'dlg' => SAPDB::Install::Wizard::Dialog::Parameter->new($this->{'wizard'}->{'dlg_space'},$this->{'next_id'}++,[0,0],wxDefaultSize)}
					);
	
	$this->{'wizard'}->AddStep({'name' => 'Software Settings',
								'dlg' => SAPDB::Install::Wizard::Dialog::Collector->new($this->{'wizard'}->{'dlg_space'},$this->{'next_id'}++,[0,0],wxDefaultSize)}
					);
	

	$this->{'wizard'}->AddStep({'name' => 'Prepare Software',
								'dlg' => SAPDB::Install::Wizard::Dialog::Prepare->new($this->{'wizard'}->{'dlg_space'},$this->{'next_id'}++,[0,0],wxDefaultSize)}
					);
	
	$this->{'wizard'}->AddStep({'name' => 'Software Installation',
								'dlg' => SAPDB::Install::Wizard::Dialog::Install->new($this->{'wizard'}->{'dlg_space'},$this->{'next_id'}++,[0,0],wxDefaultSize)}
					);
	
	$this->{'wizard'}->AddStep({'name' => 'Create DB Instance',
								'dlg' => SAPDB::Install::Wizard::Dialog::CreateInstance->new($this->{'wizard'}->{'dlg_space'},$this->{'next_id'}++,[0,0],wxDefaultSize)}
					);
	
	$this->{'wizard'}->AddStep({'name' => 'Finalization',
								'dlg' => SAPDB::Install::Wizard::Dialog::Finalize->new($this->{'wizard'}->{'dlg_space'},$this->{'next_id'}++,[0,0],wxDefaultSize)}
								);
	
	$this->{'wizard'}->init;

	EVT_SIZE($this,\&OnSize);
	$this->Show(1);
	$this->{'wizard'}->SetFocus;
    $this;
}

sub OnSize{
	my ($self,$event) = @_;
	$self->{'banner'}->SetSize([$self->GetClientSize->GetWidth,80]);	
	$self->{'wizard'}->SetSize([$self->GetClientSize->GetWidth,$self->GetClientSize->GetHeight - 80]);
	return 1;
}

1;
