#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_27/sys/src/install/perl/SAPDB/Install/LoadWx.pm#1 $
# $DateTime: 2006/04/27 14:44:55 $
# $Change: 124736 $
#
# Desc: Resource module of SDBSETUP
#

package SAPDB::Install::LoadWx;

my $archname = $SAPDB::Install::Config{'RuntimeDir'}.'/WXPERL.TGZ';
push @INC, $archname if (-f $archname);
push @INC, $SAPDB::Install::Config{'TmpLDPath'}
	if defined $SAPDB::Install::Config{'TmpLDPath'};

# make sure that shared object is found
push @INC, $SAPDB::Install::Config{'RuntimeDir'};



if($^O =~ /linux/i and defined $SAPDB::Install::Config{'UPUser'}){
	my @pwent = getpwnam($SAPDB::Install::Config{'UPUser'});
	my $homedir = $pwent[7];
	if(-d $homedir){
		my $qtrcdir = "$homedir/.qt";
		if(-d $qtrcdir){
			$ENV{'QT_HOME_DIR'} = $qtrcdir;
		}
	}
}

unless($SAPDB::Install::Config{'NO_SPLASH'}){
	my $rc;
	eval{
		$rc = require SDB::Wx::Splash;
	}; die ("cannot load wxWidgets properly: $@") if $@;
	
	unless(defined $rc){
		die("cannot load wxWidgets properly: module returned false\n");
	}
	eval{
		my $location = $SAPDB::Install::Config{'RuntimeDir'}.'/RESOURCES.TGZ';
		my $filename = 'splash/MaxDBLogo.png';
		my $splash = SDB::Wx::Splash->new ($location, $filename, 0);
	}; die ("cannot show splash screen: $@") if $@;
}

my $rc;
eval{
	$rc = require Wx;
}; die ("cannot load wxWidgets properly: $@") if $@;

unless(defined $rc){
	die("cannot load wxWidgets properly: module returned false\n");
}

$SAPDB::Install::Values::GUI_MODE = 1;


1;
