#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_27/sys/src/install/perl/SAPDB/Install/Menu/Database.pm#1 $
# $DateTime: 2006/04/27 14:44:55 $
# $Change: 124736 $
#
# Desc: 

package SAPDB::Install::Menu::Database;

use Wx::Event qw ();

use Wx qw ();

use base SAPDB::Install::Menu::Base;
use SAPDB::Install::Resources;

our $images;

our $members = {};

sub new{
	my $class = shift;
	my $dbname = shift;
	my $state = shift;
	my ($self ) = $class->SUPER::new('Database '.$dbname.($state =~ /\S/ ? " ($state)" : ' (Disconnected)') , @_);

	my @item_desc = (
		{
			'label' => '&Connect',
			'help' => 'Establish database connection',
			'image' => 'icon/connect.png',
			'disable' => $state =~ /\S/
		},
		{
			'label' => '&Disconnect',
			'help' => 'Release database connection',
			'image' => 'icon/disconnect.png',
			'disable' => $state !~ /\S/ 
		},
		undef,
		{
			'label' => '&Online',
			'help' => 'Start database',
			'image' => 'icon/green.png',
			'disable' => ($state !~ /\S/ or $state =~ /warm|online/i)
		},
		{
			'label' => '&Admin',
			'help' => 'Bring datase in admin mode',
			'image' => 'icon/yellow.png',
			'disable' => ($state !~ /\S/ or $state =~ /cold|admin/i)
		},
		{
			'label' => 'O&ffline',
			'help' => 'Shutdown database',
			'image' => 'icon/red.png',
			'disable' => ($state !~ /\S/ or $state =~ /offline/i)
		}
	);
	
	if ($^O =~ /mswin/i){
		require SAPDB::Install::Registry;
		push @item_desc,
				undef,
				{
					'label' => 'Send to Database &Manager',
					'help' => 'Start DBM Gui for this database',
					'image' => 'icon/dbm.png',
					'disable' => ($state !~ /\S/ or 
									not -f SAPDB::Install::Registry::GetDBMGui())
				},
				{
					'label' => 'Send to SQL &Studio',
					'help' => 'Start SQL Studio for this Database',
					'image' => 'icon/sqlstudio.png',
					'disable' => ($state !~ /\S/ || $state !~ /warm|online/i  or
								 not -f SAPDB::Install::Registry::GetSQLStudio())
				};
	}

	$self->InitItems(\@item_desc);
	return $self;
}

sub Destroy{
	my ($self) = @_;
	$self->SUPER::Destroy;
}

sub DESTROY{
	my ($self) = @_;
	print ">>>> DESTROY $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}

1;