#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_27/sys/src/install/perl/SAPDB/Install/Migrate/DBRegistrations.pm#1 $
# $DateTime: 2006/04/27 14:44:55 $
# $Change: 124736 $
#
# Desc: 

package SAPDB::Install::Migrate::DBRegistrations;

require SDB::Common::Exporter;

our $DEBUG=0;
our @ISA = qw (SDB::Common::Exporter);
our @EXPORT = qw (migrateDBRegistrations);

use SAPDB::Install::StdIO;
use SAPDB::Install::Values;
use SAPDB::Install::Registry;
use SAPDB::Install::Tools;
use SAPDB::Install::MD5Sum;
use SAPDB::Install::System;
use SAPDB::Install::Trace;

sub migrateDBRegistrations{
	my ($instPath) = @_;
	return if $^O =~ /mswin/i;
	my ($indep_data,$indep_prog) = readIndepPath();
	my $db_reg_ini = $indep_data.'/config/Databases.ini';
	
	my %ini_data = readini($ini_path) if -f ($ini_path);
	my $old_dbs = {};
	if(defined %ini_data and exists $ini_data{'Databases'} and ref($ini_data{'Databases'}) eq 'HASH'){
		$old_dbs = $ini_data{'Databases'}; 
	} 
	
	%ini_data = ();

	%ini_data = readini($db_reg_ini) if -f ($db_reg_ini);
	my $new_dbs = {};
	if(defined %ini_data and exists $ini_data{'Databases'} and ref($ini_data{'Databases'}) eq 'HASH'){
		$new_dbs = $ini_data{'Databases'}; 
	}

	my @dbs2mig;
	foreach my $db (keys(%$old_dbs)){
		next if $db =~ /^[\._]/;
		if($old_dbs->{$db} eq $instPath){
			push @dbs2mig,$db; 
		}
	}
	my @already_migrated;
	foreach my $db (keys(%$new_dbs)){
		next if $db =~ /^[\._]/;
		if($new_dbs->{$db} eq $instPath){
			push @already_migrated,$db; 
		}
	}	
	my @migrate_now = minus(\@dbs2mig,\@already_migrated);
	
	if($#migrate_now > -1){
		my %db_reg;
		foreach my $db (@migrate_now){
			$SAPDB::Install::Values::log->SetMsg("MSG: add new registration of instance $db\n");
			$db_reg{$db} = $instPath; 	
		}
		writeini($db_reg_ini,{'add_key' => {'Databases' => \%db_reg}});	
	}

	if($#dbs2mig > -1){
		my %db_reg;
		foreach my $db (@dbs2mig){
			$db_reg{$db} = $instPath;
			$SAPDB::Install::Values::log->SetMsg("MSG: remove old registration of instance $db\n");
 		}
		writeini($ini_path,{'delete_key' => {'Databases' => \%db_reg}});	
	}
}

1;