#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_27/sys/src/install/perl/SAPDB/Install/SetDebug.pm#1 $
# $DateTime: 2006/04/27 14:44:55 $
# $Change: 124736 $
#
# Desc: module set $DEBUG vars for loaded modules using --debug option



package SAPDB::Install::SetDebug;

require SDB::Common::Exporter;
our @ISA = qw (SDB::Common::Exporter);
our @EXPORT = qw (SetDebug printSymbols); 

use SDB::Common::Getopt::Long;
use SAPDB::Install::Trace;
use SAPDB::Install::StdIO;

sub SetDebug{
	local (*ARGV)=@_;
	# keep unused argument in @ARGV
	SDB::Common::Getopt::Long::Configure ('pass_through');
	%opt_ctrl=(
		'debug=s' => \$debug,
		'trace=s'  => \$trace
	);
	GetOptions(%opt_ctrl);
	if(defined $debug){
		my @packs = split(' ',$debug);
		foreach my $packname (@packs){
			defined %{"SAPDB::Install::${packname}::"} or print "SetDebug: module \"SAPDB::Install::$packname\" dont exist\n" and next;
			${"SAPDB::Install::${packname}::DEBUG"}=1;
		}
	}
	
	if(defined $trace){
		$trace =~ /\D/ and print2stderr("non numeric character in trace option found - remove\n");
		$trace =~ s/\D//g;
		$trace =~ /\d+/ or print2stderr("no valid trace level set\n") and return 1;
		$trace >= 0 and $trace < 6 or print2stderr("trace level out of range - set it to 5\n") and TraceLevel(5) and return 1;
		TraceLevel($trace);
	}	

	
}

sub printSymbols{
        my ($arg_package)=@_;
        my ($package,$module,$line)=caller unless defined $package;
        defined $arg_package and $package=$arg_package;
        defined %{"${package}::"} || print "module $package unkown\n" && return; 
        foreach my $symname  (keys(%{"${package}::"})){
               my $found = 0;
               print "\$$package\::$symname = ".${${%{"${package}::"}}{$symname}}."\n" and $found = 1 if defined ${"${package}::$symname"};
               print "\@$package\::$symname = ".@{${%{"${package}::"}}{$symname}}."\n"  and $found = 1 if defined @{"${package}::$symname"};
               print "\%$package\::$symname = ".%{${%{"${package}::"}}{$symname}}."\n"  and $found = 1 if defined %{"${package}::$symname"};
               print "\&$package\::$symname  is defined\n" and $found = 1 if defined &{"${package}::$symname"};
               $found || print "\*$symname\n";
        }
}


1;