#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_27/sys/src/install/perl/SAPDB/Install/SysInfo.pm#1 $
# $DateTime: 2006/04/27 14:44:55 $
# $Change: 124736 $
#

package SAPDB::Install::SysInfo;

bootstrap SAPDB::Install::SysInfo;

require SDB::Common::Exporter;

our @ISA = qw (SDB::Common::Exporter);

our @EXPORT = qw (GetSystemInfo IsRunnable);

use SAPDB::Install::PipeExec;

sub AUTOLOAD {
	die "cannot load symbol ".$AUTOLOAD."\n"
		unless ($AUTOLOAD =~ /bootstrap$/);

	require XSLoader;
	XSLoader::load (__PACKAGE__);
}

#
# main
#
sub main {
	return (SAPDB::Install::SysInfo::Test::main (@_));
}

package SAPDB::Install::SysInfo::Test;

our $DEBUG = 0;

use SDB::Common::Getopt::Long;

sub main {
	my $sysinfo = SAPDB::Install::SysInfo::GetSystemInfo ();

	if (exists $sysinfo->{'system'}) {
		print "System        : ".$sysinfo->{'system'}."\n";
	}

	if (exists $sysinfo->{'architecture'}) {
		print "Architecture  : ".$sysinfo->{'architecture'}."\n";
	}

	if (exists $sysinfo->{'version'}) {
		print "Version       : ".$sysinfo->{'version'}."\n";
	}

	if (exists $sysinfo->{'subversion'}) {
		print "Subversion    : ".$sysinfo->{'subversion'}."\n";
	}

	if (exists $sysinfo->{'c_runtime'}) {
		print "C Runtime     : ".$sysinfo->{'c_runtime'}."\n";
	}

	if (exists $sysinfo->{'cpp_runtime'}) {
		print "C++ Runtime   : ".$sysinfo->{'cpp_runtime'}."\n";
	}

	if (exists $sysinfo->{'cpp_runtime64'}) {
		print "C++ Runtime 64: ".$sysinfo->{'cpp_runtime64'}."\n";
	}

	return 0;
}

1;
