package SAPDB::Install::Templates2::Debug;
use strict;
our $SCRIPTING;
BEGIN{
  $SCRIPTING=0;
}
our $DEBUG_LEVEL=0;
our $LOGSTREAM;
our $VERBOSE;


if($SCRIPTING){
  require Exporter;
  our @ISA = qw( Exporter );
}
else{
  require SDB::Common::Exporter;
  our @ISA = qw (SDB::Common::Exporter);
  require SAPDB::Install::Values;
}
our @EXPORT  = qw (Debugit
                   Logit
                   printHashRef
                   Statusit
                   datePrefix
                   dateString
                   $SCRIPTING
                   $DEBUG_LEVEL
                   $LOGSTREAM
                   $VERBOSE
                  );

sub Debugit{
  my ($level,$txt) = @_;
  $DEBUG_LEVEL < $level and return;
  outputwrapper($txt);
}


sub dateString{
  my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
  $mon += 1;
  $year += 1900;
  my $dateString = sprintf("%02d/%02d/%02d %02d:%02d:%02d", $mon,$mday,$year % 100,$hour,$min,$sec);
  return $dateString;
}
sub datePrefix{
  return '['. dateString . '] ';
}
sub chchp{
  my $txt = shift;
  chomp $txt;
  $txt =~ s/\n$//;
  $txt =~ s/\r$//;
  $txt .= "\n";
  return $txt;
}


sub Statusit{
  my ($date,$txt) = @_;
  writeOut($txt);
}

sub Logit{
  my ($txt,$retVal) = @_;
  outputwrapper($txt);
  return $retVal;
}
sub outputwrapper{
  my $txt = shift;
  $txt = chchp($txt);
  $txt =  datePrefix() .$txt;
  writeOut($txt);
}

sub writeOut{
  my $txt = shift;
  if($SCRIPTING){
    my $str = $LOGSTREAM;
    $str and  print $str $txt;
    $VERBOSE and print $txt;
  }
  else{
    if( $SAPDB::Install::Values::log){
      $SAPDB::Install::Values::log->SetMsg($txt);
    }
    else{
       print $txt;
    }
  }
}


sub printHashRef{
  my $hr = shift;
  print "$hr\n";
  foreach(keys %$hr){
    print " ",$_,"='",$hr->{$_},"'\n";
  }
}








1;

