package   SAPDB::Install::Templates2::test::CmdLineTest;

use SAPDB::Install::Templates2::Debug;
use SAPDB::Install::Templates2::Util;
use SAPDB::Install::Templates2::CmdLine;
use strict;



our @ISA;
our @EXPORT = qw (allTests);
if($SCRIPTING){
  push @ISA,qw(Exporter);
  require Data::Dumper;
  import Data::Dumper;
}
else{
  require SDB::Common::Exporter;
  push @ISA,qw(SDB::Common::Exporter);
}

my ($templateFile,$cmdLine);
sub setUp{
  $cmdLine = newCmdLine();
}


sub tearDown{
  undef $cmdLine;
}

sub testDefaultTemplateDescriptions{
  $cmdLine->defaultTemplateDescriptions() or return "ERROR";
  return 0;
}


sub testshow{
  my $retVal=0;
  my $info ;

  my $list = SAPDB::Install::Templates2::TemplateList::createTemplateList('batch');
  foreach my $section (@$list) {
    my $label = $section->{'label'};
#    $retVal .=$label . "\n";
    my $data = $section->{'data'};
    foreach my $tmpl (@$data) {
      my $code = $tmpl->{'TemplateCode'};
      my $descr = $tmpl->{'ShortDescription'};
      $retVal = show($code,\$info) and return $retVal;
      #print $info;
    }
  }
  return $retVal;
}

sub testusage{
  my $retVal=0;
  my $txt =  $cmdLine->getUsage(); 
#  print "$txt\n";
  return 0;
}
sub testInitOptions3{
  my $retVal;
  my $atemplate = 'custom';
  my $afile=undef;
  my $aparams = ['SOMETHING=sfdsdsf','DBNAME=SCHROTT'];
  $retVal = $cmdLine->initOptions3('custom',$afile,$aparams);
  $retVal =~ /unknown/i or return "Asserting failed: SOMETHING: \"$retVal\"";

  $aparams = ['DEPENDENDPATH c:/sdb/programs','DBNAME  SCHROTT'];
  $retVal = $cmdLine->initOptions3('custom',$afile,$aparams)
    and return "Assertion failed: \"$retVal\"" ;


  
  return 0;
}

sub testConfigurationLines{
  push @ARGV, ("-f", $templateFile,
               "-p" ,"DBNAME=MAXDB2",
               "-t" ,"custom"
              );

  return 0;
}


sub allTests{
  $templateFile = shift;
#  $templateFile = 'FSDSDFDFS';
  unitTest(__PACKAGE__);
}


1;

# Local Variables: ***
# eval: (setq my-sdbrun (format "%s\\sys\\src\\install\\perl\\sdbrun" "c:\\SapDevelop\\aw")) ***
# eval: (setq my-script (format "%s\\sys\\wrk\\script" "c:\\SapDevelop\\aw")) ***
# eval: (setq my-src (format "%s\\sys\\src\\install\\perl" (sdb-get-current-own))) ***
# eval: (setq perl-dbg-flags (format "-w -I%s -I%s\\readkey -I%s -I%s" my-sdbrun my-sdbrun my-script my-src )) ***
# End: ***
