#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_27/sys/src/install/perl/SAPDB/Install/User/SyncMan/Config/Java.pm#1 $
# $DateTime: 2006/04/27 14:44:55 $
# $Change: 124736 $
#
# Desc: 

package SAPDB::Install::User::SyncMan::Config::Java;

use SAPDB::Install::User::Config::Helpers;
use SAPDB::Install::User::Config::Base;

our @ISA = qw(SAPDB::Install::User::Config::Base);

our @java_params = (
	{	'name' => 'JAVAPATH',
		'desc' => 'path to java executable',
		'default' => (get_java_path()),
		'validator' => sub {
							my ($java_path) = @_;
							my $java = $java_path.($^O =~ /mswin/i ? '\java.exe' : '/java');
							unless(-f $java){
								print STDERR "$java: $!\n";
								return 0;
							}
							my $version = get_java_version($java);
							unless($version =~ /^1\.4\./){
								print STDERR "wrong java version\n";
								print STDERR "your versions is $version\n";
								print STDERR "you need java version 1.4\n";
								return 0;
							}
							return 1;	
						}				
	},
	{	'name' => 'J2EEPATH',
		'desc' => 'path to j2ee.jar file',
		'default' => '',
		'validator' => sub {
							my ($path) = @_;
							unless(-f $path.'/j2ee.jar'){
								print STDERR "j2ee.jar not found\n";
								return 0;
							}
							return 1;	
						}				
	}
);	

sub new{
	my $self = shift->SUPER::new(@_);
	unless(defined $self->{'config_file'}){
		$self->{'config_file'} = get_syncman_configfile();
	}
	$self->{'params'} = \@java_params;
	return $self;
}


1;