#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_27/sys/src/install/perl/SAPDB/Install/User/SyncMan/Config/SyncService.pm#1 $
# $DateTime: 2006/04/27 14:44:55 $
# $Change: 124736 $
#
# Desc: 

package SAPDB::Install::User::SyncMan::Config::SyncService;

use SAPDB::Install::User::Config::Base;
use SAPDB::Install::User::Config::Helpers;
use SAPDB::Install::User::SyncMan::Acc;

our @ISA = qw(SAPDB::Install::User::Config::Base);

our @syncservice_params = (
	#{	'name' => 'DB_HOST',
	#	'desc' => 'database host',
	#	'default' => '127.0.0.1',
	#	'validator' => sub {
	#						my ($host) =@_;
	#						return 0 if $host !~ /\S/;
	#						return 1; 
	#					}
	#},
	{	'name' => 'DB_NAME',
		'desc' => 'database name',
		'default' => 'MAXDB2',
		'validator' => \&check_dbname
	},
	{	'name' => 'USER',
		'desc' => 'synchronization user',
		'default' => 'DBSERVICE',
		'validator' => sub {
							return 1;					
						}
	},
	{	'name' => 'PASSWORD',
		'desc' => 'synchronization user password',
		'default' => 'SECRET',
		'validator' => \&check_passwd,
		'type' => 'PASSWORD'
	},
	{	'name' => 'MSG_SERVER',
		'desc' => 'message server host',
		'default' => '127.0.0.1',
		'validator' => sub {
							my ($host) =@_;
							return 0 if $host !~ /\S/;
							return 1; 
						}
	},
	{	'name' => 'SYNC_SERVICE_ADMIN_PORT',
		'desc' => 'synchronization service admin port',
		'default' => '7223',
		'validator' => \&check_port
	},
	{	'name' => 'JNDI_SERVER_PORT',
		'desc' => 'JNDI port of message server',
		'default' => '7221',
		'validator' => \&check_port
	},
	{	'name' => 'MSG_SERVER_PORT',
		'desc' => 'service port of message server',
		'default' => '7222',
		'validator' => \&check_port
	}
);



sub new{
	my $self = shift->SUPER::new(@_);
	$self->{'params'} = \@syncservice_params;
	unless(defined $self->{'accesskey'}){
		if(defined $self->{'database'}){
			$self->{'accesskey'} = gen_syncservice_accesskey($self->{'database'});
		}
	}
	return $self;
}

sub load{
	my ($self) = @_;
	unless(exists $self->{'accesskey'} && defined $self->{'accesskey'}){
		return 0;
	}
	$self->{'configuration'} = {};
	unless(exists $self->{'syncmanacc'} && defined $self->{'syncmanacc'}){
		$self->{'syncmanacc'} = SAPDB::Install::User::SyncMan::Acc->new($self->{'accesskey'});
		unless(defined $self->{'syncmanacc'}){
			return 0;
		}
	}
	if($self->{'syncmanacc'}->list($self->{'configuration'}) != 0){
		return 0;
	}
	return 1;
}

sub write{
	my ($self) = @_;
	unless(defined $self->{'accesskey'}){
		$self->{'accesskey'} = gen_syncservice_accesskey($self->{'configuration'}->{'DB_NAME'});
	}	
	unless(exists $self->{'syncmanacc'} && defined $self->{'syncmanacc'}){
		$self->{'syncmanacc'} = SAPDB::Install::User::SyncMan::Acc->new($self->{'accesskey'});
		unless(defined $self->{'syncmanacc'}){
			return 0;
		}
	}
	$self->{'configuration'}->{'DB_HOST'} = '127.0.0.1';
	if ($self->{'syncmanacc'}->set($self->{'configuration'}) != 0){
		return 0;
	}
	return 1;
}





1;