package SAPDB::Install::Window::DBUser;

use base SAPDB::Install::Grid::Base;

our @columns = (
	{
		'label' => 'Description',
		'struct_key' => 'Description',
		'type' => 'string',
		'readonly' => 1
	},
	{
		'label' => 'User Name',
		'struct_key' => 'Name',
		'type' => 'string',
		'readonly' => 0
	},
	{
		'label' => 'User Password',
		'struct_key' => 'Password',
		'type' => 'password',
		'readonly' => 0
	},
	{
		'label' => 'Confirm Password',
		'struct_key' => 'ConfirmPassword',
		'type' => 'password',
		'readonly' => 0
	}
);


sub SetValue{
	my ($self,$user) = @_;
	return undef unless(ref($user) eq 'ARRAY');	
	return $self->SUPER::init(\@columns,$user);
}

sub GetValue{
	my ($self) = @_; 
	return $self->SUPER::GetValue(\@columns);
}

sub Fit{
	my ($self) = @_;
	return $self->SUPER::Fit(\@columns);
}


sub Destroy{
	my ($self) = @_;
	$self->SUPER::Destroy;
}

sub DESTROY{
	my ($self) = @_;
	print ">>>>> destroying $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}


1;