package SAPDB::Install::Window::ParamView;

use Wx qw(wxALIGN_CENTER wxVERTICAL
		  wxEXPAND wxTOP);

our @ISA = qw(Wx::Panel);

sub new{
	my $this = shift->SUPER::new(@_);
	my $sizer = Wx::BoxSizer->new(wxVERTICAL);
	$this->{'table'} = [];
	$this->{'grid'} = Wx::Grid->new($this,-1);
	#$sizer->Add($this->{'grid'},1,wxEXPAND | wxALIGN_CENTER);
	$this->SetSizer($sizer);
	$this->SetAutoLayout(1);
	return $this;
}

sub AddParameter{
	my ($self,$paramdesc) = @_;
	local *tab = $self->{'table'};
	push @tab,[$paramdesc->{'label'},$paramdesc->{'value'},$paramdesc->{'desc'}];
}

sub init{
	my ($self) = @_;
	my $rows = $#{@{$self->{'table'}}} + 1;
	my $columns = $#{@{$self->{'table'}->[0]}} + 1;
	$self->{'grid'}->CreateGrid($rows,$columns);
	$self->{'grid'}->SetRowLabelSize(30);
	$self->{'grid'}->SetColLabelSize(20);
	$self->{'grid'}->EnableEditing(0);
	$self->{'grid'}->DisableDragGridSize;
	$self->{'grid'}->SetColLabelValue(0,'Parameter');
	$self->{'grid'}->SetColLabelValue(1,'Value');
	$self->{'grid'}->SetColLabelValue(2,'Description');
	for my $row (0 .. ($rows - 1)){
		$self->{'grid'}->SetColSize( $row, 150 );
		foreach my $col (0 .. ($columns - 1)){
			$self->{'grid'}->SetCellValue($row,$col, $self->{'table'}->[$row]->[$col]);
		}
		$self->{'grid'}->AutoSize;
	}
	$self->GetSizer->Remove($self->{'grid'});
	$self->{'grid'}->SetSize([600,400]);
	$self->{'grid'}->Fit;
	$self->GetSizer->Add($self->{'grid'},0,wxALIGN_CENTER | wxTOP,50);
}

sub Destroy{
	my ($self) = @_;
	while($self->GetSizer->Remove(0)){};
	$self->{'grid'}->Destroy;
	delete $self->{'grid'};
	delete $self->{'table'};
	$self->SUPER::Destroy;
}

sub DESTROY{
	my ($self) = @_;
	print ">>>>> destroying $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}



1;